import { Router } from 'express';
import axios from 'axios';
import { CONSTANTS_KC, TEXT_CONSTANTS } from '../constants';
import { Ticker, PayType, OrderStatus, User } from '../models_nosql';
import {
	handlerTotalBalance,
	getMerchantOrders,
	getUserPayMethods,
	getMerchantAdvs,
	getArraySortedByProp,
	getArrayFilteredByProp,
	getOrderDetails,
	getTickerPriceUSDT,
	checkOrderInDB,
	insertOrderToDB,
	getP2POrders,
	getSpotOrders,
	getP2POrdersNomalized,
	getSpotOrdersNomalized,
	getMerchantAdvsNomalized,
	getMerchantOrdersNomalized,
	getBalancesNormalized,
	getPayMethodProps,
	getPaySubAccount,
	getSingleUserProperty,
	consoleProcessed,
	getOrderDetailsNomalized,
	getObjectRequestParams,
} from '../common';
const {
	SHORT_NAME,
	GET_SPOT_BALANCE,
	GET_P2P_BALANCE,
	TRANSFER_ASSET_FROM_P2P,
	TRANSFER_ASSET_FROM_SPOT,
	GET_P2P_ORDERS,
	GET_MERCHANT_ORDERS,
	GET_MERCHANT_ORDER_DETAILS,
	GET_MERCHANT_ADVS,
	CHANGE_STATUS_ADVS,
	GET_ADV_DETAIL,
	UPDATE_DETAILS_ADV,
	GET_HISTORY_SPOT_ORDERS,
	GET_ACTIVE_SPOT_ORDERS,
	GET_MERCHANT_ADV_PAYMENTS,
	GET_MERCHANT_DETAILS,
} = CONSTANTS_KC;

export const ordersRouter_KC = Router();

// получение балансов
ordersRouter_KC.post('/get-balances', async (req, res) => {
	const { userId, exchangeId, shortName } = req.body;
	const user = await User.findOne({ _id: userId });

	const objParams = {
		userId,
		shortName,
		prefix: `balance_${shortName}`,
		constants: CONSTANTS_KC,
		// apiKeys,
		requestHeader: getSingleUserProperty(
			'requestHeader',
			exchangeId,
			user.properties
		),
		additionals: {},
	};

	const totalBalance = await handlerTotalBalance(objParams);

	return res.status(200).json({
		success: totalBalance.spotBalance.length === 0 ? false : true,
		balances: totalBalance,
		message:
			totalBalance.spotBalance.length === 0
				? `${shortName}: ${TEXT_CONSTANTS.BALANCE_ER}`
				: `${shortName}: ${TEXT_CONSTANTS.BALANCE_OK}`,
	});
});

// получение массива объявлений
ordersRouter_KC.post('/merchant-advs', async (req, res) => {
	const { userId, shortName, exchangeId } = req.body;
	const user = await User.findOne({ _id: userId });

	const objParams = {
		userId,
		prefix: `advs_${shortName}`,
		constants: CONSTANTS_KC,
		// apiKeys,
		requestHeader: getSingleUserProperty(
			'requestHeader',
			exchangeId,
			user.properties
		),
		additionals: {},
	};

	const objReqParams = getObjectRequestParams(objParams);
	const arrData = await getMerchantAdvs(objReqParams);
	const arrPayTypes = await PayType.find();

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			// merchantAdvs: [],
			merchantAdvs:
				arrData.length !== 0
					? getMerchantAdvsNomalized(
							arrData,
							{
								userId,
								exchangeId,
								prefix: shortName,
							},
							arrPayTypes
					  )
					: [],
			userPayMethods: [],
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ADVS_ER}`,
	});
});

// изменение статуса объявления (-ий) мерчанта
ordersRouter_KC.post('/adv-status', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_STATUS_ER}`,
	});
});

// получение редактируемого объявления мерчанта
ordersRouter_KC.post('/adv-edit', async (req, res) => {
	res.status(400).json({
		error,
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_EDIT_ER}`,
	});
});

// обновление редактируемого объявления
ordersRouter_KC.post('/adv-update', async (req, res) => {
	res.status(400).json({
		message: `${SHORT_NAME}: ${TEXT_CONSTANTS.ADV_UPDATE_ER}`,
	});
});

// получение массива p2p-ордеров стакана
ordersRouter_KC.post('/p2p', async (req, res) => {
	const { userId, exchangeId, shortName } = req.body;
	const {
		asset,
		fiat,
		arrPayments,
		sideType,
		page,
		amount,
	} = req.body.objParams;
	const quantityPages = +req.body.objParams.quantityPages / 20;
	const arrPayTypes = await PayType.find();
	const tradeType = sideType === 'BUY' ? 'SELL' : 'BUY';
	// const paymentNames =
	// 	arrPayments.length === 0
	// 		? []
	// 		: arrPayments.map((item, index) => {
	// 				return getPayMethodPropsReverse(
	// 					exchangeId,
	// 					'payName', // payId or payName
	// 					item, // internalPayMethod
	// 					arrPayTypes
	// 				);
	// 		  });

	const user = await User.findOne({ _id: userId });
	const requestHeaderKC = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			withCredentials: true,
			method: GET_P2P_ORDERS.method,
			url: ``,
			data: null,
			headers: {
				'access-control-allow-credentials': true,
				'Access-Control-Allow-Origin': '*',
				'content-type': 'application/json;charset=UTF-8',
				cookie: requestHeaderKC.cookie,
				'user-agent': requestHeaderKC.userAgent,
			},
		},
	};

	let arrData = [];
	for (let i = page; i <= quantityPages; i++) {
		params.config.url = `${GET_P2P_ORDERS.url}?currency=${asset}&side=${tradeType}&legal=${fiat}&page=${i}&pageSize=20&status=PUTUP&lang=en_US`;
		const result = await getP2POrders(params);
		arrData = arrData.concat(result);
	}

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		data: {
			// p2pOrders: [],
			p2pOrders:
				arrData.length !== 0
					? getP2POrdersNomalized(
							arrData,
							{
								userId,
								exchangeId,
								prefix: shortName,
							},
							arrPayTypes
					  )
					: [],
			tickers: await Ticker.find(),
		},
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.P2P_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.P2P_ORDERS_ER}`,
	});
});

// получение массива текущих merchant-ордеров
ordersRouter_KC.post('/merchant-orders', async (req, res) => {
	const { userId, exchangeId, shortName, objParams } = req.body;

	const user = await User.findOne({ _id: userId });
	const requestHeaderKC = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const params = {
		userId,
		prefix: shortName,
		config: {
			withCredentials: true,
			method: GET_MERCHANT_ORDERS.method,
			url: `${GET_MERCHANT_ORDERS.url}?page=${objParams.page}&pageSize=${objParams.rows}&lang=en_US`,
			data: null,
			headers: {
				'access-control-allow-credentials': true,
				'Access-Control-Allow-Origin': '*',
				'content-type': 'application/json;charset=UTF-8',
				cookie: requestHeaderKC.cookie,
				'user-agent': requestHeaderKC.userAgent,
			},
		},
	};
	const arrData = await getMerchantOrders(params);
	const arrPayTypes = await PayType.find();
	const arrOrderStatus = await OrderStatus.find();

	return res.status(200).json({
		success: arrData.length !== 0 ? true : false,
		// data: arrData,
		data:
			arrData.length !== 0
				? getMerchantOrdersNomalized(
						arrData,
						{
							userId,
							exchangeId,
							prefix: shortName,
						},
						arrPayTypes,
						arrOrderStatus
				  )
				: [],
		message:
			arrData.length !== 0
				? `${shortName}: ${arrData.length} ${TEXT_CONSTANTS.USER_ORDERS_OK}`
				: `${shortName}: ${TEXT_CONSTANTS.USER_ORDERS_ER}`,
	});
});

// получение сведений об мерчанте и его объявлениях по id
ordersRouter_KC.get('/merchant-details/:id', async (req, res) => {
	const merchantId = req.params.id;
	const axiosRequestConfig = {
		method: GET_MERCHANT_DETAILS.method,
		url: `${GET_MERCHANT_DETAILS.url}?userNo=${merchantId}`,
		data: null,
		headers: null,
	};
	await axios(axiosRequestConfig)
		.then((response) => {
			// console.log(response.data)
			return res.status(200).json({
				success: true,
				data: response.data.data,
				message: `${SHORT_NAME}: ${TEXT_CONSTANTS.USER_DETAILS_OK}`,
			});
		})
		.catch((error) => {
			res.status(400).json({
				error,
				message: `${SHORT_NAME}: ${TEXT_CONSTANTS.USER_DETAILS_ER}`,
			});
		});
});

// сохранение данных об merchant-ордере в БД по id
ordersRouter_KC.post('/save-user-orders', async (req, res) => {
	const { userId, orders, typeOrder, shortName, exchangeId } = req.body;
	const user = await User.findOne({ _id: userId });
	const arrTickers = await Ticker.find(); // тикеры и цены из БД
	const arrPayTypes = await PayType.find(); // типы оплаты из БД
	let countOrder = 0;

	const requestHeaderKC = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const headers = {
		'access-control-allow-credentials': true,
		'Access-Control-Allow-Origin': '*',
		'content-type': 'application/json;charset=UTF-8',
		cookie: requestHeaderKC.cookie,
		'user-agent': requestHeaderKC.userAgent,
	};

	// проверка наличия ордера в БД
	for (let i = 0; i < orders.length; i++) {
		if (orders[i] !== null) {
			const result = await checkOrderInDB(
				userId,
				typeOrder,
				orders[i],
				shortName
			);

			// Если ордера нет в БД
			if (result.isUnique) {
				const config = {
					method: GET_MERCHANT_ORDER_DETAILS.method,
					url: `${GET_MERCHANT_ORDER_DETAILS.url}${orders[i]}`,
					data: null,
					headers,
				};
				// получение данных об ордере с биржи
				const orderDetails = await getOrderDetails(
					config,
					shortName,
					typeOrder
				);

				const params = {
					userId,
					shortName,
					exchangeId,
					arrTickers,
					arrPayTypes,
					orderDetails,
				};

				// если статус ордера "Completed" вставляем в БД
				const newOrder =
					orderDetails.status === 'CHARGED'
						? getOrderDetailsNomalized(params)
						: {};
				// если newOrder не пустой объект - сохраняем в БД
				if (Object.keys(newOrder).length !== 0) {
					await insertOrderToDB(typeOrder, newOrder);
					// console.log(`${countOrder} | Number: ${newOrder.orderId} | payMethodName: ${newOrder.payMethodName}`);
					++countOrder;
				}
			}
		}
	}

	// log print
	consoleProcessed(userId, shortName, orders, countOrder, typeOrder);

	return res.status(200).json({
		success: true,
		message: `${shortName}: ${countOrder} inserted`,
	});
});

// получение массива активных spot-ордеров
ordersRouter_KC.post('/spot-orders-active', async (req, res) => {
	const { userId, exchange, exchangeId, shortName } = req.body;
	const arrTickers = await Ticker.find();
	let status = 200;

	const user = await User.findOne({ _id: userId });
	const requestHeaderKC = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	// // проверям существуют ли куки на этом сервисе
	// if (requestHeaderKC.userAgent === '') {
	// 	return res.status(status).json({
	// 		success: true,
	// 		message: `${shortName}: requestHeader is empty`,
	// 		spotOrders: [],
	// 		tickers: arrTickers,
	// 	});
	// }

	const objParams = {
		userId,
		prefix: `active_${shortName}`,
		// apiKeys,
		requestHeader: requestHeaderKC,
		constants: CONSTANTS_KC,
		additionals: {},
	};

	const objReqParams = getObjectRequestParams(objParams);
	const arrActiveSpots = await getSpotOrders(objReqParams);

	return res.status(status).json({
		success: arrActiveSpots.length === 0 ? false : true,
		message:
			arrActiveSpots.length === 0
				? `${shortName}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`
				: `${shortName}: ${arrActiveSpots.length} ${TEXT_CONSTANTS.SPOT_ORDERS_OK}`,
		spotOrders:
			arrActiveSpots.length === 0
				? []
				: getSpotOrdersNomalized(
						arrActiveSpots,
						{
							userId,
							shortName,
							exchangeId,
							flag: `active_${shortName}`,
						},
						arrTickers
				  ),
		tickers: arrTickers,
	});
});

// сохранение spot-ордеров в БД
ordersRouter_KC.post('/spot-orders-history', async (req, res) => {
	let message;
	let success = true;
	let status = 200;
	let countOrder = 0;

	const {
		userId,
		exchange,
		exchangeId,
		shortName,
		typeOrder,
		params,
	} = req.body;

	const user = await User.findOne({ _id: userId });
	const requestHeaderKC = getSingleUserProperty(
		'requestHeader',
		exchangeId,
		user.properties
	);

	const objParams = {
		userId,
		prefix: `history_${shortName}`,
		// apiKeys,
		requestHeader: requestHeaderKC,
		constants: CONSTANTS_KC,
		additionals: {},
	};

	const objReqParams = getObjectRequestParams(objParams);
	const spotArray = await getSpotOrders(objReqParams);

	// Если ордера не получены
	if (spotArray === null) {
		success = false;
		message = `${shortName}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`;
		return res.status(status).json({
			success,
			message,
		});
	}

	const arrTickers = await Ticker.find();
	const spotOrders = getSpotOrdersNomalized(
		spotArray,
		{
			userId,
			shortName,
			exchangeId,
			flag: `history_${shortName}`,
		},
		arrTickers
	);

	if (spotOrders.length !== 0) {
		// проверка наличия ордера в БД
		for (let i = 0; i < spotOrders.length; i++) {
			const result = await checkOrderInDB(
				spotOrders[i].userId,
				typeOrder,
				spotOrders[i].orderId,
				spotOrders[i].exchange
			);

			// Если ордера нет в БД вставляем
			if (result.isUnique) {
				// если newSpotOrder не пустой объект - сохраняем в БД
				if (Object.keys(spotOrders[i]).length !== 0) {
					await insertOrderToDB('SPOT', spotOrders[i]);
					// console.log(
					// 	// `${countOrder} | orderId: ****${spotOrders[i].orderId.slice(
					// 	// 	-5
					// 	// )} inserted`
					// 	spotOrders[i]
					// );
					++countOrder;
				}
			}
			// else console.log(`Order ${spotOrders[i].orderId} is not Unique`);
		}
		if (countOrder === 0) {
			success = false;
			message = `${shortName}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_NO}`;
		} else {
			success = true;
			message = `${shortName}: ${countOrder} | ${TEXT_CONSTANTS.SPOT_ORDERS_DB_OK}`;
		}
	} else {
		success = false;
		message = `${shortName}: ${TEXT_CONSTANTS.SPOT_ORDERS_ER}`;
	}

	// log print
	consoleProcessed(userId, shortName, spotOrders, countOrder, typeOrder);

	return res.status(status).json({
		success,
		message,
	});
});
